/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package site1;

import java.io.IOException;
import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketAddress;
import java.util.ArrayList;

/**
 *
 * @author mudromar
 */
public class Server {

    private ArrayList<Data> list = new ArrayList<Data>();

    ServerSocket serverSocket;
    Socket clientSocket;

    public static void main(String[] args) throws IOException {
        Server srv = new Server();
        srv.run();
    }

    public void run() throws IOException {
        // ziskani portu nebo chyba
        try {
            serverSocket = new ServerSocket(65000);

        } catch (IOException e) {
            System.out.println("Port je uz obsazen.");
            e.printStackTrace();
            System.exit(-1);
        }

// ziskani bezneho socketu - bude se cekat do pripojeni klienta!
        try {
            System.out.println("Accept():");
            clientSocket = serverSocket.accept();
            System.out.println("Pripojen klient");
            //nejaka cinnost
            InputStream is = clientSocket.getInputStream();
            BufferedReader br = new BufferedReader(new InputStreamReader(is));

            OutputStream os = clientSocket.getOutputStream();
            OutputStreamWriter osw = new OutputStreamWriter(os);

            int stage = 0;
            String helo = "";
            String IDText = "";
            String eventText = "";
            String entryText = "";

            while (stage != 100) {
                switch (stage) {
                    case 0:
                        helo = br.readLine();
                        if (helo.startsWith("HELO ")) {
                            System.out.println("Prijato HELO: " + helo.substring(5));
                            osw.write("OK\n");
                            osw.flush();
                            stage++;
                        } else if (helo.startsWith("KONECPROGRAMU")) {
                            System.out.println("VYPIS Listu");
                            System.out.println(list);
                            System.out.println("KONEC vypisu");
                        } else {
                            stage = 100;
                        }
                        break;
                    case 1:
                        IDText = br.readLine();
                        if (IDText.startsWith("ID ")) {
                            System.out.println("Prijato ID: " + IDText.substring(3));
                            osw.write("OK\n");
                            osw.flush();
                            stage++;
                        } else {
                            stage = 100;
                        }
                        break;
                    case 2:
                        eventText = br.readLine();
                        if (eventText.startsWith("EVENT ")) {
                            System.out.println("Prijat EVENT: " + eventText.substring(6));
                            osw.write("OK\n");
                            osw.flush();
                            stage++;
                        } else {
                            stage = 100;
                        }
                        break;

                    case 3:
                        entryText = br.readLine();
                        if (entryText.startsWith("ENTRY")) {
                            System.out.println("Prijato ENTRY");
                            osw.write("OK\n");
                            list.add(new Data(helo.substring(5), IDText.substring(3), eventText.substring(6), true));
                            osw.flush();
                        } else if (entryText.startsWith("EXIT")) {
                            System.out.println("Prijato EXIT");
                            osw.write("OK\n");
                            list.add(new Data(helo.substring(5), IDText.substring(3), eventText.substring(6), false));
                            osw.flush();
                        }
                        stage = 100;
                        break;
                }
                System.out.println("stage = " + stage);
            }
            System.out.println("Cinnost probehla");

            osw.write("BYE\n");
            osw.flush();
            br.close();
            is.close();
            osw.close();
            os.close();

            System.out.println(list);

        } catch (IOException e) {
            System.out.println("Pripojeni selhalo.");
            e.printStackTrace();
            System.exit(-1);
        } finally {
            clientSocket.close();
            serverSocket.close();
        }
    }
}
